;-------------------------------------
; project LedDigits
; przeksztacenie zmiennej 2-bajtowej
; do postaci szeregowej
;-------------------------------------

LedDg SEGMENT CODE

;definicje linii
EQU	dataline		P1.0
EQU	shiftline	P1.1
EQU	latchline	P1.2


;deklaracja dostpu z poziomu jzyka C
PUBLIC _WordSend


RSEG LedDg


;wysanie bajtu
_WordSend:		ANL	P1,#0F8H		;zerowanie linii danych i zegarowych
					MOV	B,#8			;rejestr B jako licznik operacji
WSendLoop1:		MOV	A,R6			;parametry s przekazywane w R6 i R7
					RLC	A				;do CY stan bit
					MOV	R6,A
					MOV	dataline,C	;CY ustawia stan linii danych
					SETB	shiftline
					CLR	shiftline
					DJNZ	B,WSendLoop1

					MOV	B,#8			;rejestr B jako licznik operacji
WSendLoop2:		MOV	A,R7			;teraz R7
					RLC	A				;do CY stan bit
					MOV	R7,A
					MOV	dataline,C	;CY ustawia stan linii danych
					SETB	shiftline
					CLR	shiftline
					DJNZ	B,WSendLoop2
					
					SETB	latchline	;zapis do wyj rejestrw
					CLR	latchline
					
					RET



END
